﻿import es
import langlib
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"

texts = langlib.Strings(lang_dir + "cap/popup_admin_cap.ini")
messages = langlib.Strings(lang_dir + "cap/messages_cap.ini")

# ******************** Load ********************
def load():
	es.addons.registerSayFilter(filter)

# ******************** Events ********************
def filter(userid, text, teamonly):
	steamid = es.getplayersteamid(userid)
	if es.exists("key", "sm_keygroup_set", steamid) == 1:
		text = text.strip('"')
		type = es.keygetvalue("sm_keygroup_set", steamid, "setting_type")
		if type == "cap_fight_health":
			set_value(userid, text, "health", 5, 0, 1, 250)
			return (0, None, 0)
		elif type == "cap_fight_speed":
			set_value(userid, text, "speed", 6, 2, 0.1, 10)
			return (0, None, 0)
		elif type == "cap_fight_jump":
			set_value(userid, text, "jump", 7, 0, 0, 250)
			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def set_value(userid, text, type, number, decimals, min, max):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if text != "!cancel":
		error = messages("type_%s" % (type), tokens, player.get("lang"))
		try:
			if decimals == 0:
				value = int(round(float(text), 0))
			else:
				value = round(float(text), decimals)

			if value >= min:
				if value <= max:
					es.set("sm_cap_fight_%s" % (type), value)

					popuplib.find("sm_popup_admin_cap").modline((number + 2), "->%s. %s: %s" % (number, texts(type), value))

					tokens["name"] = player.name
					tokens["value"] = value
					lang_msg("set_%s" % (type), tokens)

					es.keydelete("sm_keygroup_set", player.steamid)
					popuplib.send("sm_popup_admin_cap", userid)
				else:
					es.tell(userid, "#green", error)
			else:
				es.tell(userid, "#green", error)
		except ValueError:
			es.tell(userid, "#green", error)
	else:
		es.keydelete("sm_keygroup_set", player.steamid)
		popuplib.send("sm_popup_admin_cap", userid)

# ******************** Unload ********************
def unload():
	es.addons.unregisterSayFilter(filter)