﻿import es
import langlib
import os
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"
skins_folder = str("cstrike/models/player")

common = langlib.Strings(lang_dir + "popup_common.ini")
texts = langlib.Strings(lang_dir + "skins/popup_admin_skins.ini")
messages = langlib.Strings(lang_dir + "skins/messages_skins.ini")
messages_common = langlib.Strings(lang_dir + "messages_common.ini")

popup = popuplib.create("sm_popup_admin_skins")

gks = []
personal = []

settings = ["t", "ct", "t_gk", "ct_gk"]

# ******************** Load ********************
def load():
	for item in settings:
		es.set("sm_skins_%s" % (item), es.ServerVar("sm_skins_default_%s" % (item)))

	if os.path.isfile("cstrike/cfg/soccer_mod/es_soccer_mod_skins_db.txt") == True:
		es.keygroupload("soccer_mod_skins", "soccer_mod")

	create_popup()

# ******************** Create popup ********************
def create_popup():
	popup.addline("SOCCER MOD %s" % (texts("title")))
	popup.addline(" ")

	for i in range(0, len(settings)):
		value = str(es.ServerVar("sm_skins_%s" % (settings[i])))
		popup.addline("->%s. %s: %s" % (i + 1, texts(settings[i]), value[14:len(value)]))
		popup.select(i + 1, choose_skin)

	popup.addline("->5. %s" % (texts("reset")))
	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.select(5, reset)

	for i in range(6, 9):
		popup.submenu(i, "sm_popup_admin_skins")

	popup.submenu(9, "sm_popup_admin")

# ******************** Events ********************
def player_disconnect(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if event_var["es_steamid"] in gks:
			gks.remove(event_var["es_steamid"])

		if event_var["es_steamid"] in personal:
			personal.remove(event_var["es_steamid"])

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		skin_check(event_var["userid"])

# ******************** Popup choice ********************
def choose_skin(userid, choice, popupid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	if choice == 1:
		type = "tp"
	elif choice == 2:
		type = "cp"
	elif choice == 3:
		type = "tg"
	elif choice == 4:
		type = "cg"

	open_path(name, skins_folder, type)

	popuplib.send(name, userid)

def reset(userid, choice, popupid):
	player = playerlib.getPlayer(userid)

	skins = ["t", "ct", "t_gk", "ct_gk"]
	number = 1
	for item in skins:
		value = es.keygetvalue("soccer_mod_settings", "skins", "default_%s" % (item))
		popup.modline((number + 2), "->%s. %s: %s" % (number, texts(item), value[14:len(value)]))
		es.set("sm_skins_%s" % (item), value)
		number += 1

	set_t()
	set_ct()
	set_t_gk()
	set_ct_gk()

	es.doblock("soccer_mod_2010/downloads/refresh_downloads")

	tokens = {}
	tokens["name"] = player.name
	lang_msg("reset", tokens)

	popuplib.send("sm_popup_admin_skins", userid)

# ******************** Commands ********************
def cmd_gk():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if player.steamid not in gks:
			gks.append(player.steamid)
			es.tell(userid, "#green", messages("gk", tokens, player.get("lang")))
		else:
			gks.remove(player.steamid)
			es.tell(userid, "#green", messages("no_gk", tokens, player.get("lang")))

		skin_check(userid)
	else:
		es.tell(userid, "#green", messages_common("not_allowed", tokens, player.get("lang")))

def cmd_personal():
	tokens = {}
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if es.ServerVar("soccer_mod_allowed") == 1:
		if es.exists("key", "soccer_mod_skins", player.steamid) == 1:
			if player.steamid not in personal:
				personal.append(player.steamid)
				es.tell(userid, "#green", messages("personal", tokens, player.get("lang")))
			else:
				personal.remove(player.steamid)
				es.tell(userid, "#green", messages("no_personal", tokens, player.get("lang")))

			skin_check(userid)
		else:
			es.tell(userid, "#green", messages("no_personal_skin", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("not_allowed", tokens, player.get("lang")))

# ******************** Functions ********************
def set_skin(userid, model):
	es.server.queuecmd("playerset model %s %s" % (userid, model))

def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def open_path(popup_name, path, team):
	myPopup = popuplib.easymenu(popup_name, None, choice)
	myPopup.settitle(texts("select"))

	dirup = path.split("/")

	length = len(dirup) - 1
	dir = ""
	for i in range(0, length):
		if i < (length - 1):
			dir += dirup[i] + "/"
		else:
			dir += dirup[i]

	if path != skins_folder:
		myPopup.addoption("dir_" + team + "_" + dir, "^ " + texts("up") + " ^")

	list = os.listdir(path)
	list.sort()
	for item in list:
		if os.path.isdir(path + "/" + item) == True:
			myPopup.addoption("dir_" + team + "_" + path + "/" + item, "(" + texts("folder") + ") " + item)

	list = os.listdir(path)
	list.sort()
	for item in list:
		if os.path.isdir(path + "/" + item) == False:
			type = item.split(".")
			length = len(type) - 1
			if type[length] == "mdl":
				myPopup.addoption("file_" + team + "_" + path + "/" + item, item)

	myPopup.submenu(10, "sm_popup_admin_skins")

def choice(userid, choice, keymenuname):
	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	length = len(choice)

	type = choice.split("_")
	if type[0] == "dir":
		path = choice[7:length]
		open_path(popup_name, path, type[1])
		popuplib.send(popup_name, userid)
	else:
		player = playerlib.getPlayer(userid)
		value = choice[16:length]

		tokens = {}
		tokens["name"] = player.name
		tokens["value"] = value[14:len(value)]

		if type[1] == "tp":
			es.set("sm_skins_t", value)

			set_t()

			line = "->1. %s: %s" % (texts("t"), value[14:len(value)])
			popup.modline(3, line)

			lang_msg("t", tokens)
		elif type[1] == "cp":
			es.set("sm_skins_ct", value)

			set_ct()

			line = "->2. %s: %s" % (texts("ct"), value[14:len(value)])
			popup.modline(4, line)

			lang_msg("ct", tokens)
		elif type[1] == "tg":
			es.set("sm_skins_t_gk", value)

			set_t_gk()

			line = "->3. %s: %s" % (texts("t_gk"), value[14:len(value)])
			popup.modline(5, line)

			lang_msg("t_gk", tokens)
		elif type[1] == "cg":
			es.set("sm_skins_ct_gk", value)

			set_ct_gk()

			line = "->4. %s: %s" % (texts("ct_gk"), value[14:len(value)])
			popup.modline(6, line)

			lang_msg("ct_gk", tokens)

		es.doblock("soccer_mod_2010/downloads/refresh_downloads")

		popuplib.send("sm_popup_admin_skins", userid)

def set_t():
	set_team_skin("sm_skins_t", "#t,#alive")

def set_ct():
	set_team_skin("sm_skins_ct", "#ct,#alive")

def set_team_skin(cvar, users):
	for player in playerlib.getPlayerList(users):
		if player.steamid not in gks:
			set_skin(player.userid, es.ServerVar(cvar))

def set_t_gk():
	set_gk_skin("sm_skins_t_gk", "#t,#alive")

def set_ct_gk():
	set_gk_skin("sm_skins_ct_gk", "#ct,#alive")

def set_gk_skin(cvar, users):
	for player in playerlib.getPlayerList(users):
		if player.steamid in gks:
			set_skin(player.userid, es.ServerVar(cvar))

def skin_check(userid):
	player = playerlib.getPlayer(userid)
	if player.team > 1:
		if player.team == 2:
			team = "t"
		else:
			team = "ct"

		exists = es.exists("key", "soccer_mod_skins", player.steamid)

		if exists == 1:
			value = es.keygetvalue("soccer_mod_skins", player.steamid, team)
			if value != "":
				if player.steamid in personal:
					set_skin(userid, value)
				else:
					if player.steamid in gks:
						set_skin(userid, es.ServerVar("sm_skins_%s_gk" % (team)))
					else:
						set_skin(userid, es.ServerVar("sm_skins_%s" % (team)))
			else:
				if player.steamid in gks:
					set_skin(userid, es.ServerVar("sm_skins_%s_gk" % (team)))
				else:
					set_skin(userid, es.ServerVar("sm_skins_%s" % (team)))

		if exists == 0:
			if player.steamid in gks:
				set_skin(userid, es.ServerVar("sm_skins_%s_gk" % (team)))
			else:
				set_skin(userid, es.ServerVar("sm_skins_%s" % (team)))

# ******************** Unload ********************
def unload():
	if es.exists("keygroup", "soccer_mod_skins") == 1:
		es.keygroupdelete("soccer_mod_skins")

	popuplib.delete("sm_popup_admin_skins")